package content.global.interaction.item.equipment

import core.api.consts.Items
import core.plugin.Initializable
import core.plugin.Plugin

@Initializable
class PVPEquipmentRegister : Plugin<Any> {

    val TICKS = 6000

    val VESTA_BODY = arrayOf(Items.VESTAS_CHAINBODY_13887, Items.VESTAS_CHAINBODY_DEG_13889)
    val VESTA_SKIRT = arrayOf(Items.VESTAS_PLATESKIRT_13893, Items.VESTAS_PLATESKIRT_DEG_13895)
    val VESTA_LONGSWORD = arrayOf(Items.VESTAS_LONGSWORD_13899, Items.VESTAS_LONGSWORD_DEG_13901)
    val VESTA_SPEAR = arrayOf(Items.VESTAS_SPEAR_13905, Items.VESTAS_SPEAR_DEG_13907)

    val STATIUS_BODY = arrayOf(Items.STATIUS_PLATEBODY_13884, Items.STATIUS_PLATEBODY_DEG_13886)
    val STATIUS_LEGS = arrayOf(Items.STATIUS_PLATELEGS_13890, Items.STATIUS_PLATELEGS_DEG_13892)
    val STATIUS_HELM = arrayOf(Items.STATIUS_FULL_HELM_13896, Items.STATIUS_FULL_HELM_DEG_13898)
    val STATIUS_WARHAMMER = arrayOf(Items.STATIUS_WARHAMMER_13902, Items.STATIUS_WARHAMMER_DEG_13904)

    val ZURIEL_TOP = arrayOf(Items.ZURIELS_ROBE_TOP_13858, Items.ZURIELS_ROBE_TOP_DEG_13860)
    val ZUREL_BOTTOM = arrayOf(Items.ZURIELS_ROBE_BOTTOM_13861, Items.ZURIELS_ROBE_BOTTOM_DEG_13863)
    val ZURIEL_HOOD = arrayOf(Items.ZURIELS_HOOD_13864, Items.ZURIELS_HOOD_DEG_13866)
    val ZURIEL_STAFF = arrayOf(Items.ZURIELS_STAFF_13867, Items.ZURIELS_STAFF_DEG_13869)

    val MORRIGAN_BODY = arrayOf(Items.MORRIGANS_LEATHER_BODY_13870, Items.MORRIGANS_LEATHER_BODY_DEG_13872)
    val MORRIGAN_CHAPS = arrayOf(Items.MORRIGANS_LEATHER_CHAPS_13873, Items.MORRIGANS_LEATHER_CHAPS_DEG_13875)
    val MORRIGAN_COIF = arrayOf(Items.MORRIGANS_COIF_13876, Items.MORRIGANS_COIF_DEG_13878)

    val TICKS_C = 1500

    val CORRUPT_VESTA_BODY = arrayOf(Items.CORRUPT_VESTAS_CHAINBODY_13911, Items.CORRUPT_VESTAS_CHAINBODY_DEG_13913)
    val CORRUPT_VESTA_SKIRT = arrayOf(Items.CORRUPT_VESTAS_PLATESKIRT_13917, Items.CORRUPT_VESTAS_PLATESKIRT_DEG_13919)
    val CORRUPT_VESTA_LONGSWORD = arrayOf(Items.CORRUPT_VESTAS_LONGSWORD_13924, Items.CORRUPT_VESTAS_LONGSWORD_DEG_13925)
    val CORRUPT_VESTA_SPEAR = arrayOf(Items.CORRUPT_VESTAS_SPEAR_13929, Items.CORRUPT_VESTAS_SPEAR_DEG_13931)

    val CORRUPT_STATIUS_BODY = arrayOf(Items.CORRUPT_STATIUS_PLATEBODY_13908, Items.CORRUPT_STATIUS_PLATEBODY_DEG_13910)
    val CORRUPT_STATIUS_LEGS = arrayOf(Items.CORRUPT_STATIUS_PLATELEGS_13914, Items.CORRUPT_STATIUS_PLATELEGS_DEG_13916)
    val CORRUPT_STATIUS_HELM = arrayOf(Items.CORRUPT_STATIUS_FULL_HELM_13920, Items.CORRUPT_STATIUS_FULL_HELM_DEG_13922)
    val CORRUPT_STATIUS_WARHAMMER = arrayOf(Items.CORRUPT_STATIUS_WARHAMMER_13926, Items.CORRUPT_STATIUS_WARHAMMER_DEG_13928)

    val CORRUPT_ZURIEL_TOP = arrayOf(Items.CORRUPT_ZURIELS_ROBE_TOP_13932, Items.CORRUPT_ZURIELS_ROBE_TOP_DEG_13934)
    val CORRUPT_ZUREL_BOTTOM = arrayOf(Items.CORRUPT_ZURIELS_ROBE_BOTTOM_13935, Items.CORRUPT_ZURIELS_ROBE_BOTTOM_DEG_13937)
    val CORRUPT_ZURIEL_HOOD = arrayOf(Items.CORRUPT_ZURIELS_HOOD_13938, Items.CORRUPT_ZURIELS_HOOD_DEG_13940)
    val CORRUPT_ZURIEL_STAFF = arrayOf(Items.CORRUPT_ZURIELS_STAFF_13941, Items.CORRUPT_ZURIELS_STAFF_DEG_13943)

    val CORRUPT_MORRIGAN_BODY = arrayOf(Items.CORRUPT_MORRIGANS_LEATHER_BODY_13944, Items.CORRUPT_MORRIGANS_LEATHER_BODY_DEG_13946)
    val CORRUPT_MORRIGAN_CHAPS = arrayOf(Items.CORRUPT_MORRIGANS_LEATHER_CHAPS_13947, Items.CORRUPT_MORRIGANS_LEATHER_CHAPS_DEG_13949)
    val CORRUPT_MORRIGAN_COIF = arrayOf(Items.CORRUPT_MORRIGANS_COIF_13950, Items.CORRUPT_MORRIGANS_COIF_DEG_13952)

    val TICKS_D = 3000

    val CORRUPT_DRAGON_BODY = arrayOf(Items.CORRUPT_DRAGON_CHAINBODY_13958, Items.CORRUPT_DRAGON_CHAINBODY_DEG_13960)
    val CORRUPT_DRAGON_LEGS = arrayOf(Items.CORRUPT_DRAGON_PLATELEGS_13970, Items.CORRUPT_DRAGON_PLATELEGS_DEG_13972)
    val CORRUPT_DRAGON_HELM = arrayOf(Items.CORRUPT_DRAGON_MED_HELM_13961, Items.CORRUPT_DRAGON_MED_HELM_DEG_13963)
    val CORRUPT_DRAGON_SQ_SHIELD = arrayOf(Items.CORRUPT_DRAGON_SQ_SHIELD_13964, Items.CORRUPT_DRAGON_SQ_SHIELD_DEG_13966)
    val CORRUPT_DRAGON_SKIRT = arrayOf(Items.CORRUPT_DRAGON_PLATESKIRT_13967, Items.CORRUPT_DRAGON_PLATESKIRT_DEG_13969)
    val CORRUPT_DRAGON_BATTLEAXE = arrayOf(Items.CORRUPT_DRAGON_BATTLEAXE_13973, Items.CORRUPT_DRAGON_BATTLEAXE_DEG_13975)
    val CORRUPT_DRAGON_DAGGER = arrayOf(Items.CORRUPT_DRAGON_DAGGER_13976, Items.CORRUPT_DRAGON_DAGGER_DEG_13978)
    val CORRUPT_DRAGON_SCIMITAR = arrayOf(Items.CORRUPT_DRAGON_SCIMITAR_13979, Items.CORRUPT_DRAGON_SCIMITAR_DEG_13981)
    val CORRUPT_DRAGON_LONGSWORD = arrayOf(Items.CORRUPT_DRAGON_LONGSWORD_13982, Items.CORRUPT_DRAGON_LONGSWORD_DEG_13984)
    val CORRUPT_DRAGON_MACE = arrayOf(Items.CORRUPT_DRAGON_MACE_13985, Items.CORRUPT_DRAGON_MACE_DEG_13987)
    val CORRUPT_DRAGON_SPEAR = arrayOf(Items.CORRUPT_DRAGON_SPEAR_13988, Items.CORRUPT_DRAGON_SPEAR_DEG_13990)

    override fun newInstance(arg: Any?): Plugin<Any> {
        EquipmentDegrader.registerSet(TICKS, VESTA_BODY)
        EquipmentDegrader.registerSet(TICKS, VESTA_SKIRT)
        EquipmentDegrader.registerSet(TICKS, VESTA_LONGSWORD)
        EquipmentDegrader.registerSet(TICKS, VESTA_SPEAR)
        EquipmentDegrader.registerSet(TICKS, STATIUS_BODY)
        EquipmentDegrader.registerSet(TICKS, STATIUS_WARHAMMER)
        EquipmentDegrader.registerSet(TICKS, STATIUS_HELM)
        EquipmentDegrader.registerSet(TICKS, STATIUS_LEGS)
        EquipmentDegrader.registerSet(TICKS, ZUREL_BOTTOM)
        EquipmentDegrader.registerSet(TICKS, ZURIEL_HOOD)
        EquipmentDegrader.registerSet(TICKS, ZURIEL_STAFF)
        EquipmentDegrader.registerSet(TICKS, ZURIEL_TOP)
        EquipmentDegrader.registerSet(TICKS, MORRIGAN_BODY)
        EquipmentDegrader.registerSet(TICKS, MORRIGAN_CHAPS)
        EquipmentDegrader.registerSet(TICKS, MORRIGAN_COIF)

        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_VESTA_BODY)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_VESTA_SKIRT)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_VESTA_LONGSWORD)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_VESTA_SPEAR)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_STATIUS_BODY)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_STATIUS_WARHAMMER)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_STATIUS_HELM)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_STATIUS_LEGS)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_ZUREL_BOTTOM)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_ZURIEL_HOOD)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_ZURIEL_STAFF)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_ZURIEL_TOP)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_MORRIGAN_BODY)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_MORRIGAN_CHAPS)
        EquipmentDegrader.registerSet(TICKS_C, CORRUPT_MORRIGAN_COIF)

        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_BODY)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_LEGS)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_HELM)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_SQ_SHIELD)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_SKIRT)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_BATTLEAXE)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_DAGGER)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_SCIMITAR)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_LONGSWORD)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_MACE)
        EquipmentDegrader.registerSet(TICKS_D, CORRUPT_DRAGON_SPEAR)
        return this
    }

    override fun fireEvent(identifier: String?, vararg args: Any?): Any {
        return Unit
    }

}
